/*******************************************************
 *
 * $Id: MyActionEngine.cpp,v 1.7 2003/02/15 11:29:21 teacy Exp $
 *
 * This file has been placed in the public domain.
 *
 *******************************************************/


#include <PalmOS.h>

#include "MyActionEngine.h"
#include "gfx/SpriteEngine.h"
#include "sound/SoundEngine.h"

#include "modules/hiscore/HighscoreModel.h"

#include "FlyingChickenScreen.h"
#include "RectangleScreen.h"
#include "FlatshadeScreen.h"



MyActionEngine::MyActionEngine() : ActionEngine(4)
{
}


MyActionEngine::~MyActionEngine()
{
}

	
void MyActionEngine::init()
{
	stateDescriptors[0] = MyActionEngine::createStateDescriptor();
	stateDescriptors[1] = FlyingChickenScreen::createStateDescriptor();
	stateDescriptors[2] = RectangleScreen::createStateDescriptor();
	stateDescriptors[3] = FlatshadeScreen::createStateDescriptor();

	state = (MyActionEngineState *)(stateDescriptors[0]->state);
}


Screen *MyActionEngine::getCurrentScreen() const
{
	switch(state->currentScreen)
	{
		case 0:
			return new FlyingChickenScreen(stateDescriptors[1]);
		case 1:
			return new RectangleScreen(stateDescriptors[2]);
		case 2:
			return new FlatshadeScreen(stateDescriptors[3]);
		default:
		ErrNonFatalDisplay("Illegal current screen");
		return NULL;
	}	
}


Screen *MyActionEngine::getNextScreen()
{
	state->currentScreen++;
	
	if (state->currentScreen == 3)
	{
		state->currentScreen = 0;
	}
	
	return getCurrentScreen();
}


UInt16 MyActionEngine::getStateDescriptorsVersion() const
{
	return 1;
}


StateDescriptor *MyActionEngine::createStateDescriptor()
{
	createState(MyActionEngineState);
	
	// Initialize state
	state->currentScreen = 0;

	return stateDescriptor;
}
