/*********************************************************************************
 *
 * Razor! Engine - A modular C++ presentation engine
 *
 * $Id: Geometry.h,v 1.1 2003/01/26 10:43:18 teacy Exp $
 *
 * Copyright (c) 2000-2003 Tilo Christ. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the  "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the Software 
 * is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all 
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 **********************************************************************************/

#ifndef GEOMETRY_H
#define GEOMETRY_H

#include <PalmOS.h>
#include "RazorSections.h"


typedef struct {int x, y;} xy;
typedef struct {int x, y, z;} xyz;



/**
 * A collection of geometric functions
 */
class Geometry
{
	public:

	/**
	 * Determine a rectangle that encompasses two other rectangles.
	 *
	 * @param rect1Bound the bounds of rectangle #1
	 * @param rect2Bound the bounds of rectangle #2
	 * @param resultBound the bounds of the encompassing rectangle.
	 *        rect1Bound, or rect2Bound, and resultBound may safely point to the same RectangleType structure.
	 */
	static void uniteBounds(RectangleType *rect1Bound, RectangleType *rect2Bound, RectangleType *resultBound);

	

	private:
	Geometry();
	~Geometry();
};

#endif
