/*********************************************************************************
 *
 * Razor! Engine - A modular C++ presentation engine
 *
 * $Id: FlatshaderArmlet.h,v 1.2 2003/03/17 22:22:53 teacy Exp $
 *
 * Copyright (c) 2000-2003 Tilo Christ. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the  "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the Software 
 * is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all 
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 **********************************************************************************/


#ifndef FLATSHADER_ARMLET_H
#define FLATSHADER_ARMLET_H

#ifdef ARMLET
#include "ArmletTypes.h"
#else
#include <PalmOS.h>
#endif

typedef struct 
{
	Int16 *minxptr;
	Int16 *maxxptr;
	UInt32 rowBytes;
	UInt8 *drawBits;
	Int32 clipxr;
	Int32 clipyo;
	UInt32 vertexCount;
	void *e;
	UInt32 shiftFactor;
	UInt32 colorIdx;
} FlatShaderParamType;

#ifdef __PALMOS_ARMLET__
#ifdef __GNUC__
UInt32 NativeFunction(const void *emulStateP, void *userData68KP, Call68KFuncType *call68KFuncP);
#elif __MWERKS__
extern "C" {
unsigned long ARMlet_Main(const void *emulStateP, void *userData68KP, Call68KFuncType *call68KFuncP); 
}
#else
#error You are using an unsupported compiler
#endif
#endif

#endif
