/*********************************************************************************
 *
 * Razor! Engine - A modular C++ presentation engine
 *
 * $Id: PalmOSCanvas.h,v 1.4 2003/05/30 12:30:21 teacy Exp $
 *
 * Copyright (c) 2000-2003 Tilo Christ. All Rights Reserved.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the  "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the Software 
 * is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all 
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 **********************************************************************************/


#ifndef PALMOS_CANVAS_H
#define PALMOS_CANVAS_H

#include "Customization.h"
#include "RazorSections.h"
#include <PalmOS.h>
#include "gfx/Canvas.h"
#ifndef MODE_PURITY
#include "gfx/DirectDoubleBuffer.h"
#endif

namespace prvrazor
{


/**
 * PalmOSCanvas is the basic canvas that supports no special features in devices from PalmOS licensees.
 * It should work on all Palm OS devices. 
 */
class PalmOSCanvas : public Canvas
{
	public:
	/**
	 * Create an offscreen canvas with the specified size
	 */
	PalmOSCanvas(Coord width, Coord height, CoordSystem coordSystem) SEC_RAZOR_INIT;

	/**
	 * Create an onscreen canvas with the size of the physical display
	 */
	PalmOSCanvas() SEC_RAZOR_INIT;
	
	~PalmOSCanvas() SEC_RAZOR_INIT;

	void setOSCanvas() const;
	Boolean setForegroundColor(const Color color) const;
	Boolean setBackgroundColor(const Color color) const;

	static Boolean _setForegroundColor(const Color color);
	static Boolean _setBackgroundColor(const Color color);

	private:
	WinHandle offscreenWindow;
};

}

#endif
